const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const withdrawal_requests = sequelize.define(
    'withdrawal_requests',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

amount: {
        type: DataTypes.DECIMAL,
      
      

      },

currency: {
        type: DataTypes.TEXT,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"requested",


"approved",


"processing",


"paid",


"rejected",


"failed",


"canceled"

        ],

      },

requested_at: {
        type: DataTypes.DATE,
      
      

      },

processed_at: {
        type: DataTypes.DATE,
      
      

      },

processor_reference: {
        type: DataTypes.TEXT,
      
      

      },

failure_reason: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  withdrawal_requests.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












































//end loop



    db.withdrawal_requests.belongsTo(db.wallets, {
      as: 'wallet',
      foreignKey: {
        name: 'walletId',
      },
      constraints: false,
    });

    db.withdrawal_requests.belongsTo(db.payout_methods, {
      as: 'payout_method',
      foreignKey: {
        name: 'payout_methodId',
      },
      constraints: false,
    });

    db.withdrawal_requests.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.withdrawal_requests.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.withdrawal_requests.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return withdrawal_requests;
};


